/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Stats.xs. Do not edit this file, edit Stats.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Event/Stats.xs"
/*-*-c-*-*/
#define MIN_PERL_DEFINE 1

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#include "EventAPI.h"

static int EnforceMaxCBTime=0;

/*********************************************************/
typedef struct snap snap;
struct snap {
    double elapse;
    int live;
    int max_tm;
    struct timeval start;
};

static void snap_on(snap *sn)
{
    assert(sn);
    /* if (sn->live) warn("snap reinit"); /**/
    gettimeofday(&sn->start, 0);
    sn->live = 1;
}

static void snap_off(snap *sn)
{
  struct timeval done_tm;
  assert(sn);
  if (!sn->live) return;
  gettimeofday(&done_tm, 0);
  sn->live = 0;
  sn->elapse += (done_tm.tv_sec - sn->start.tv_sec +
		 (done_tm.tv_usec - sn->start.tv_usec)/1000000.0);
}

/*********************************************************/
#define PE_STAT_SECONDS 3  /* 3 sec per interval */
#define PE_STAT_I1  20
#define PE_STAT_I2  20

typedef struct pe_run pe_run;
struct pe_run {
  double elapse;
  int ran, die;
};

typedef struct pe_stat pe_stat;
struct pe_stat {
  int xsec, xmin;     /* first index of circular buffers */
  pe_run sec[PE_STAT_I1];
  pe_run min[PE_STAT_I2];
};

static pe_stat totalStats;
static pe_stat idleStats;
static struct timeval total_tm;
static pe_timer *RollTimer=0;

static void pe_stat_init(pe_stat *st)
{
  int xx;
  st->xsec = 0;
  for (xx=0; xx < PE_STAT_I1; xx++) {
    st->sec[xx].elapse = 0;
    st->sec[xx].ran = 0;
    st->sec[xx].die = 0;
  }
  st->xmin = 0;
  for (xx=0; xx < PE_STAT_I2; xx++) {
    st->min[xx].elapse = 0;
    st->min[xx].ran = 0;
    st->min[xx].die = 0;
  }
}

#if 0
static void pe_stat_dump(pe_stat *st) /*BROKEN*/
{
  int xx;
  fprintf(stderr,"stat(0x%x)\nsec> ", st);
  for (xx=0; xx < PE_STAT_I1; xx++) {
    pe_run *run = &st->sec[(st->xsec + xx) % PE_STAT_I1];
    fprintf(stderr, "%5.2f/%d ", run->elapse, run->ran);
  }
  fprintf(stderr,"\nmin5> ");
  for (xx=0; xx < PE_STAT_I2; xx++) {
    pe_run *run = &st->min[(st->xmin + xx) % PE_STAT_I2];
    fprintf(stderr, "%5.2f/%d ", run->elapse, run->ran);
  }
  fprintf(stderr,"\n");
}
#endif

static void pe_stat_record(pe_stat *st, double elapse)
{
  pe_run *run = &st->sec[st->xsec];
  /*  warn("recording %f\n", elapse);  pe_stat_dump(st); /**/
  run->elapse += elapse;
  run->ran += 1;
  /*  pe_stat_dump(st); /**/
}

static void pe_stat_query(pe_stat *st, int sec, int *ran, int *die, double *elapse)
{
  *ran = 0;
  *die = 0;
  *elapse = 0;
  if (sec <= 1)
    return;
  if (sec <= PE_STAT_SECONDS * PE_STAT_I1) {
    int xx;
    for (xx=0; xx <= (sec-1) / PE_STAT_SECONDS; xx++) {
      pe_run *run = &st->sec[(st->xsec + xx + 1) % PE_STAT_I1];
      assert(xx <= PE_STAT_I1);
      *ran += run->ran;
      *die += run->die;
      *elapse += run->elapse;
    }
    return;
  }
  if (sec <= PE_STAT_SECONDS * PE_STAT_I1 * PE_STAT_I2) {
    int xx;
    for (xx=0; xx <= (sec-1) / (PE_STAT_SECONDS*PE_STAT_I1); xx++) {
      pe_run *run = &st->min[(st->xmin + xx + 1) % PE_STAT_I2];
      assert(xx <= PE_STAT_I2);
      *ran += run->ran;
      *die += run->die;
      *elapse += run->elapse;
    }
    return;
  }
  warn("Stats available only for the last %d seconds (vs. %d)",
       PE_STAT_SECONDS * PE_STAT_I1 * PE_STAT_I2, sec);
}

static void pe_stat_roll(pe_stat *st)
{
  st->xsec = (st->xsec + PE_STAT_I1 - 1) % PE_STAT_I1;
  if (st->xsec == 0) {
    int xx;
    st->xmin = (st->xmin + PE_STAT_I2 - 1) % PE_STAT_I2;
    st->min[st->xmin].ran = 0;
    st->min[st->xmin].die = 0;
    st->min[st->xmin].elapse = 0;
    for (xx=0; xx < PE_STAT_I1; xx++) {
      st->min[st->xmin].ran += st->sec[xx].ran;
      st->min[st->xmin].die += st->sec[xx].die;
      st->min[st->xmin].elapse += st->sec[xx].elapse;
    }
  }
  st->sec[st->xsec].ran = 0;
  st->sec[st->xsec].die = 0;
  st->sec[st->xsec].elapse = 0;
}

static void pe_stat_roll_cb()
{
  pe_watcher *ev;
  struct timeval done_tm;
  /* warn("roll"); /**/
  gettimeofday(&done_tm, 0);
  pe_stat_record(&totalStats, (done_tm.tv_sec-total_tm.tv_sec +
			      (done_tm.tv_usec-total_tm.tv_usec)/1000000.0));
  gettimeofday(&total_tm, 0);

  ev = GEventAPI->AllWatchers->next->self;
  while (ev) {
    if (!ev->stats) {
      New(0, ev->stats, 1, pe_stat);
      pe_stat_init(ev->stats);
    }
    pe_stat_roll(ev->stats);
    ev = ev->all.next->self;
  }
  pe_stat_roll(&idleStats);
  pe_stat_roll(&totalStats);
}

static snap SysTm;       /* for idleStats */
static int RefTimes=0;
static snap *RefTime=0;

static void *pe_enter(int frame, int max_tm)
{
    snap *sn;
  /* warn("enter %d", frame); /**/
  if (frame == -1) {
      SysTm.elapse = 0;
      snap_on(&SysTm);
      return &SysTm;
  }
  if (frame >= RefTimes) {
    int cnt = frame + 10;
    if (!RefTime) {
      Newz(0, RefTime, cnt, snap);
    } else {
      int xx;
      Renew(RefTime, cnt, snap);
      for (xx=RefTimes; xx < cnt; xx++)
	RefTime[xx].live=0;
    }
    RefTimes = cnt;
  }
  sn = RefTime + frame;
  sn->elapse = 0;
  sn->max_tm = max_tm;
  snap_on(RefTime + frame);
  if (EnforceMaxCBTime && max_tm)
      alarm(max_tm);
  return sn;
}

static void pe_suspend(void *vp)
{
    if (EnforceMaxCBTime)
	alarm(0);
    snap_off((snap*)vp);
}

static void pe_resume(void *vp)
{
    snap *sn = (snap*) vp;
    if (EnforceMaxCBTime && sn->max_tm)
	alarm(sn->max_tm - ((int)sn->elapse));
    snap_on(sn);
}

static void pe_commit(void *vp, pe_watcher *wa)
{
  snap *sn = (snap*) vp;
  /* warn("commit %x %x", vp, wa); /**/
  if (EnforceMaxCBTime)
      alarm(0);
  if (wa && !wa->stats) {
    New(0, wa->stats, 1, pe_stat);
    pe_stat_init(wa->stats);
  }
  snap_off(sn);
  pe_stat_record(wa? wa->stats : &idleStats, sn->elapse);
}

static void pe_abort(void *vp, pe_watcher *wa)
{
  pe_run *run;
  pe_stat *st;
  if (EnforceMaxCBTime)
      alarm(0);
  ((snap*)vp)->live=0;
  assert(wa);
  if (!wa->stats) {
    New(0, wa->stats, 1, pe_stat);
    pe_stat_init(wa->stats);
  }
  st = (pe_stat*) wa->stats;
  run = &st->sec[st->xsec];
  run->die += 1;
}

static void pe_dtor(void *stats)
{ safefree(stats); }

static pe_event_stats_vtbl Myvtbl =
  { 0, pe_enter, pe_suspend, pe_resume, pe_commit, pe_abort, pe_dtor };

static int Stats;
static void use_stats(int yes)
{
    int prev = Stats;
    Stats += yes;
    if (Stats < 0)
	Stats=0;
    if (!(!prev ^ !Stats))
	return;
    if (Stats) {
	pe_watcher *ev;
	/*    warn("reinit stats"); /**/
	ev = GEventAPI->AllWatchers->next->self;
	while (ev) {
	    if (ev->stats)
		pe_stat_init(ev->stats);
	    ev = ev->all.next->self;
	}
	pe_stat_init(&idleStats);
	pe_stat_init(&totalStats);
  
	if (!RollTimer)
	    RollTimer = GEventAPI->new_timer(0,0);
	RollTimer->interval = newSVnv(PE_STAT_SECONDS);
	ev = (pe_watcher*) RollTimer;
	WaREPEAT_on(ev);
	sv_setpv(ev->desc, "Event::Stats");
	ev->prio = PE_PRIO_NORMAL - 1;
	ev->callback = (void*) pe_stat_roll_cb;
	gettimeofday(&total_tm, 0);
	/* pretend we are repeating so 'at' can be uninitialized */
	GEventAPI->start(ev, 1);
	GEventAPI->collect_stats(1);
    } else {
	GEventAPI->stop((pe_watcher*) RollTimer, 1);
	GEventAPI->collect_stats(0);
    }
}

#line 318 "lib/Event/Stats.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 462 "lib/Event/Stats.c"

XS_EUPXS(XS_Event__Stats__enforcing_max_callback_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats__enforcing_max_callback_time)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 325 "lib/Event/Stats.xs"
{
    XPUSHs(boolSV(EnforceMaxCBTime));
}
#line 477 "lib/Event/Stats.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Stats__enforce_max_callback_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats__enforce_max_callback_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "yes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	bool	yes = (bool)SvTRUE(ST(0))
;
#line 333 "lib/Event/Stats.xs"
{
    XPUSHs(boolSV(EnforceMaxCBTime));
    if (!EnforceMaxCBTime ^ !yes)
	use_stats(yes? 1:-1);
    EnforceMaxCBTime = yes;
    if (!yes) alarm(0);
}
#line 503 "lib/Event/Stats.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Stats_round_seconds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats_round_seconds)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	int	sec = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 345 "lib/Event/Stats.xs"
	if (sec <= 0)
	  RETVAL = PE_STAT_SECONDS;
	else if (sec < PE_STAT_SECONDS * PE_STAT_I1)
	  RETVAL = ((int)(sec + PE_STAT_SECONDS-1)/ PE_STAT_SECONDS) *
			PE_STAT_SECONDS;
	else if (sec < PE_STAT_SECONDS * PE_STAT_I1 * PE_STAT_I2)
	  RETVAL = ((int)(sec + PE_STAT_SECONDS * PE_STAT_I1 - 1) /
			       (PE_STAT_SECONDS * PE_STAT_I1)) *
			PE_STAT_SECONDS * PE_STAT_I1;
	else
	  RETVAL = PE_STAT_SECONDS * PE_STAT_I1 * PE_STAT_I2;
#line 533 "lib/Event/Stats.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Stats_idle_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats_idle_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	sec = (int)SvIV(ST(0))
;
#line 363 "lib/Event/Stats.xs"
	int ran, die;
	double elapse;
#line 554 "lib/Event/Stats.c"
#line 366 "lib/Event/Stats.xs"
	if (!Stats) croak("Event::Stats are not enabled");
	pe_stat_query(&idleStats, sec, &ran, &die, &elapse);
	XPUSHs(sv_2mortal(newSViv(ran)));
	XPUSHs(sv_2mortal(newSViv(die)));
	XPUSHs(sv_2mortal(newSVnv(elapse)));
#line 561 "lib/Event/Stats.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Stats_total_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats_total_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	sec = (int)SvIV(ST(0))
;
#line 376 "lib/Event/Stats.xs"
	int ran,die;
	double elapse;
#line 582 "lib/Event/Stats.c"
#line 379 "lib/Event/Stats.xs"
	if (!Stats) croak("Event::Stats are not enabled");
	pe_stat_query(&totalStats, sec, &ran, &die, &elapse);
	XPUSHs(sv_2mortal(newSVnv(elapse)));
#line 587 "lib/Event/Stats.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Stats_collect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Stats_collect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "yes");
    {
	int	yes = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 387 "lib/Event/Stats.xs"
{
    use_stats(yes);
    RETVAL = Stats;
}
#line 610 "lib/Event/Stats.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Watcher_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_stats)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	obj = ST(0)
;
	int	sec = (int)SvIV(ST(1))
;
#line 401 "lib/Event/Stats.xs"
	int ran, die;
	double elapse;
	pe_watcher *THIS;
#line 634 "lib/Event/Stats.c"
#line 405 "lib/Event/Stats.xs"
	if (!Stats)
		croak("Event::Stats are not enabled");
	THIS = (pe_watcher*) GEventAPI->sv_2watcher(obj);
	if (THIS->stats)
	  pe_stat_query(THIS->stats, sec, &ran, &die, &elapse);
	else
	  ran = die = elapse = 0;
	XPUSHs(sv_2mortal(newSViv(ran)));
	XPUSHs(sv_2mortal(newSViv(die)));
	XPUSHs(sv_2mortal(newSVnv(elapse)));
#line 646 "lib/Event/Stats.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Event__Stats); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Event__Stats)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Event::Stats::_enforcing_max_callback_time", XS_Event__Stats__enforcing_max_callback_time);
        newXS_deffile("Event::Stats::_enforce_max_callback_time", XS_Event__Stats__enforce_max_callback_time);
        newXS_deffile("Event::Stats::round_seconds", XS_Event__Stats_round_seconds);
        newXS_deffile("Event::Stats::idle_time", XS_Event__Stats_idle_time);
        newXS_deffile("Event::Stats::total_time", XS_Event__Stats_total_time);
        newXS_deffile("Event::Stats::collect", XS_Event__Stats_collect);
        newXS_deffile("Event::Watcher::stats", XS_Event__Watcher_stats);

    /* Initialisation Section */

#line 313 "lib/Event/Stats.xs"
     {
	HV *stash = gv_stashpv("Event::Stats", 1);
	newCONSTSUB(stash, "MINTIME", newSViv(PE_STAT_SECONDS));
	newCONSTSUB(stash, "MAXTIME",
	      newSViv(PE_STAT_SECONDS * PE_STAT_I1 * PE_STAT_I2));
	I_EVENT_API(HvNAME(stash));
	GEventAPI->install_stats(&Myvtbl);
     }

#line 700 "lib/Event/Stats.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

